unit old_tem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var  Temps : array[1..12] of double;
     i : integer;
     Filum : double;
     fitot : array[1..12] of double;
     x0,y0,vx0,vy0,incl,deltat : double;
     tmoyterre : double;
{     type_sol,relief_sol,pente_sol,vegetation : double;
     prox_mer,sorte_sol : double;}
     nbrpas,i1 : integer;
     t,dt : double;
     m1,m2,G_universel : double;
     fx,fy : double;
     sigma,Tmoysol,emrel : double;
     denom : double;
     dvx0,dvy0 : double;
     Rterre,Rsol : double;
     mu : double;
     journee : integer;
     betamax,beta,ca,cam : double;
     te1,te2,te3,pe,te : array[1..3] of double;
     zetat,tetat : double;
     i11 : integer;
     lattitude,longitude : double;
     pente,alpha : double;
     reflex,sigma_sol : double;
     fluxlum_entr,fluxlum_sort : double;
     ca_oui : double;
     absorption_flux,chaleur_latente,pluie,evaporation,rho_eau : double;
     evaporation_possible : double;
     ch1 : char;
{2002 : flux soleil} flux_soleil : double;
{2002}affiche : boolean;
{2002}t_soleil : double;


begin
  writeln('Programme de demonstration de calcul de temperature terrestre');
  writeln('en equilibre a tres long terme');
  writeln;
  writeln('Quelle est la latitude en degre ?');
  readln(lattitude);
  writeln('la latitude est de : ',lattitude:10:3);
  writeln('Quelle est la longitude en degre ?');
  readln(longitude);
  writeln('la longitude est de : ',longitude:10:3);
  writeln('Quelle est la pente moyenne du sol en pourcent ?');
  readln(pente);
  writeln('la pente moyenne est de : ',pente:10:3);
  evaporation_possible:=0.9;
  writeln('Quel est l''vaporation possible (maxima possible : 0.7)');
  writeln('                                 (minima possible   1.0)');
  writeln('(moyenne cultivable 0.9 et limitation par le programme');
  readln(evaporation_possible);
  if evaporation_possible<0.7 then evaporation_possible:=0.7;
  writeln('l''vaporation possible vaut :',evaporation_possible:10:3);
  sigma := 5.67E-8;
{  reflex:=4.4/5.67;}
{  writeln('Quel est le coefficient de luminosit(terre : 1.0)');
  writeln('                                      mer   : ND )');
  readln(reflex);}
  reflex:=1.0;
  writeln('le coefficient de luminosit vaut :',reflex:10:3);
  reflex:=reflex*4.4/5.67;
  sigma_sol:=reflex*sigma;
  writeln('Quel est l''absorption des rayons du soleil par l''atmosphre ?');
  writeln('                                 (sans nuage : approx : 0.01)');
  readln(ca_oui);
  if ca_oui>0.25 then ca_oui:=0.25;
  if ca_oui>0.1 then evaporation_possible:=0.9;
  beta:=1-ca_oui;
  writeln('l''absoption estimee des nuages vaut : ',ca_oui:10:3);
  writeln('Voulez-vous un affichage de la puissance solaire locale (o/n)?');
  readln(ch1);
  if (ch1='o') then affiche:=true
               else affiche:=false;
  {jours des mois}
  Temps[1]:=31.0;
  Temps[2]:=27.0;
  Temps[3]:=31.0;
  Temps[4]:=30.0;
  Temps[5]:=31.0;
  Temps[6]:=30.0;
  Temps[7]:=31.0;
  Temps[8]:=31.0;
  Temps[9]:=30.0;
  Temps[10]:=31.0;
  Temps[11]:=30.0;
  Temps[12]:=31.0;

  x0 := 152.1E9;
  y0 := 0.0;
  vx0 := 0.0;
  vy0 := -29409.0;
  incl := 0.2*23.44;
  writeln('l''inclinaison de la terre vu par le rayonnement vaut (degre) : ',incl:10:3);
  incl := incl * 3.1416926535 / 180.0;
   m2 := 5.974E24;
   m1 := 3.3E5 * m2;
   G_universel := 6.673E-11;
   deltat :=10*24 * 3600;
   nbrpas := 20;
   dt :=deltat/round(nbrpas);
   Tmoysol := 0.95*6273.0;
{2002 modif}writeln('la temperature du soleil (assimil photosphre) vaut (degre K) : ',Tmoysol:10:3);
{2016 modif            T_soleil := 0.5297*Tmoysol;
            writeln('la temperature du soleil (assimil chromosphre) vaut (degre K) : ',T_soleil:10:3);}
   Rterre := 6378000;
   Rsol := 109.0 * Rterre;

   for i1 := 1 to nbrpas do
     begin
       t:= t + dt;
       fx := G_universel*m1*m2*(-1);
       fy := G_universel*m1*m2*(-1);
       denom := exp(-1.5*ln(sqr(x0)+sqr(y0)));
       fx := fx * x0 * denom;
       fy := fy * y0 * denom;
       dvx0 := fx * dt / m2;
       dvy0 := fy * dt / m2;
       vx0 := vx0 + dvx0;
       vy0 := vy0 + dvy0;
       x0 :=  x0 + vx0 * dt;
       y0 :=  y0 + vy0 * dt;
     end;
  For i := 1 to 12 do
  begin
   deltat := temps[i]*24 * 3600;
   nbrpas := 20;
   dt :=deltat/round(nbrpas);
     mu := 0.0;
     zetat := lattitude*3.1415926535/180;
     tetat := longitude*3.1415926535/180;
     t:= 0.0;
     cam := 0.0;
     for journee:= 0 to 11 do
     begin
       mu := 3.1415926*journee/6.0;
       te1[1] := Rterre * sin(incl);
       te1[2] := 0.0;
       te1[3] := Rterre * cos(incl);
       te2[1] := -1.0 * Rterre * cos(incl) * cos(mu);
       te2[2] := Rterre * sin(mu);
       te2[3] := Rterre * sin(incl) * cos(mu);
       te3[1] := Rterre * sin(mu) * cos(incl);
       te3[2] := Rterre * cos(mu);
       te3[3] := -1.0 * Rterre * sin(mu) * sin(incl);
       te[1] := sin(zetat) * te1[1] + cos(zetat) * cos(tetat) * te2[1] +
                cos(zetat) * sin(tetat) * te3[1];
       te[2] := sin(zetat) * te1[2] + cos(zetat) * cos(tetat) * te2[2] +
                cos(zetat) * sin(tetat) * te3[2];
       te[3] := sin(zetat) * te1[3] + cos(zetat) * cos(tetat) * te2[3] +
                cos(zetat) * sin(tetat) * te3[3];
       pe[1] := x0 + te[1];
       pe[2] := y0 + te[2];
       pe[3] := te[3];
       ca := -1.0*(te[1]*pe[1]+te[2]*pe[2]+te[3]*pe[3])/
             (sqrt(sqr(te[1])+sqr(te[2])+sqr(te[3]))*
              sqrt(sqr(pe[1])+sqr(pe[2])+sqr(pe[3])));
       if ca<0.0 then ca := 0.0;
       cam := cam + ca/12.0;
     end;
     emrel := beta * cam * sqr(Rsol)/(sqr(x0)+sqr(y0));
     alpha:=arctan(pente/100);
     fluxlum_entr := emrel * sigma * (sqr(sqr(Tmoysol)));
     if affiche then begin
{2002 % toiles} writeln('flux moyen entrant (W/m2) :',fluxlum_entr:10:3);
     flux_soleil := sqr(Rsol)/(sqr(x0)+sqr(y0)) * sigma * (sqr(sqr(Tmoysol)));
{2002 % toiles} writeln('flux direct entrant (W/m2) :',flux_soleil:10:3);
                     end;
     Tmoyterre := sqrt(sqrt(fluxlum_entr/(1/cos(alpha))/sigma_sol
{attention: sigma_sol dans la racine quatrieme de T
 17/09/1997 : discussion avec mr le docteur ingenieur
              professeur navigateur Michel Vandenbergh
 verification : ok
 11/1997 : extreme difficulte  obtenir les capteurs
           infra-rouges corrects pour la mesure
           directe de ce rayonnement en continu}
     {Hypothse la plus probable d'quirayonnement entrant sur terre et
     sortant de l''atmosphre : beta*}));
     Tmoyterre:=tmoyterre-273.15;
{1996 if (Tmoyterre<-200) then writeln('! azote et oxygene liquides!')
                         else writeln;}
     absorption_flux:=1.0-evaporation_possible;
     chaleur_latente:=2250000;
     rho_eau:=1000;
     evaporation:=absorption_flux*fluxlum_entr/rho_eau/chaleur_latente/3.1416;
     pluie:=evaporation*1000*24*3600*temps[i];
{2011}Tmoyterre := sqrt(sqrt(fluxlum_entr*(1-absorption_flux)
                             /(1/cos(alpha))/sigma_sol));
     Tmoyterre:=tmoyterre-273.15;
{1996}if (Tmoyterre<-200) then writeln('! azote et oxygene liquides!');
     writeln('mois : ',i:4,'   temperature calculee : ',tmoyterre:10:3,' C');
     writeln('       ',i:4,'   pluie       calculee : ',pluie:10:3,' mm/mois');
     for i1 := 1 to nbrpas do
     begin
       t:= t + dt;
       fx := G_universel*m1*m2*(-1);
       fy := G_universel*m1*m2*(-1);
       denom := exp(-1.5*ln(sqr(x0)+sqr(y0)));
       fx := fx * x0 * denom;
       fy := fy * y0 * denom;
       dvx0 := fx * dt / m2;
       dvy0 := fy * dt / m2;
       vx0 := vx0 + dvx0;
       vy0 := vy0 + dvy0;
       x0 :=  x0 + vx0 * dt;
       y0 :=  y0 + vy0 * dt;
     end;
  end;
  readln(ch1);
  writeln('Programme climatique conu et ralis par');
  writeln('Eddy Heyden');
  writeln('Anne 1995');
  writeln('Revise Salon Eureka 1996');
  writeln('Rvis affichage 2002');
  writeln('generalisation 2003 en cause Millenium et XP');
  writeln('mise a jour pluie 2011');
end;
end.








